//
//
//  Generated by StarUML(tm) Java Add-In
//
//  @ Project : Race Simulation
//  @ File Name : Event.java
//  @ Date : 2007-07-12
//  @ Author : 
//
//

package hopital.evenements;

import hopital.Entite;

import java.io.Serializable;
import java.util.Iterator;
import java.util.Vector;


public abstract class Evenement extends Thread implements Serializable {
    
	private Vector<Entite> entites;
	boolean echec;
	
    /**
     * Structure d'�v�nement
     */
    public Evenement() {
        echec = false;
    }
    
    /**
     * Permet au sous classes de determiner si l'exception a failli.
     * @param echec Vrai si �a a failli.
     */
    protected void setEchec(boolean echec)
    {
        this.echec = echec;
    }
    
    /**
     * Permet au monde de savoir si l'exception a failli.
     * @return Vrai si �a a failli.
     */
    public boolean hasEchec()
    {
        return this.echec;
    }
    
    /**
     * Execution de base d'un evenement. C'est a dire qu'on avise toutes les entites
     * inscrite que l'evenement est survenue.
     * 
     * La methode est final parce que ce qu'elle fait ne devrait pas avoir a etre
     * redefini et en plus, elle demarre un thread et on veut s'assurer que tout va bien.
     */
    public final void executer()
    {
        if (getState().equals(Thread.State.NEW))
            start();
        else
            demarrer();
    }
    
    /**
     * Executee lorsque la methode execute start le Thread.
     */
    public void run()
    {
    	demarrer();
    }
    
    /**
     * Simplement pour que ce soit possible de gerer le cas ou on execute le meme Event
     * plusieurs fois.
     *
     */
    private void demarrer()
    {
    	Iterator<Entite> it = entites.iterator();
        while (it.hasNext())
        {
            ((Entite)it.next()).traiterEvenement(this);
        }
    }
    
    /**
     * Ajoute un entite dans la liste des inscrits.
     * @param entity L'entite inscrite.
     */
    public void inscrire(Entite entity)
    {
        entites.add(entity);
    }
    
    /**
     * Desinscrit un utilisateur.
     * @param entity L'entite desinscrite.
     */
    public void desincrire(Entite entity)
    {
    	entites.remove(entity);
    }
 
    
    /*
    public static void attachObserver(ObservateurEvenements observer)
    {
    	observers.add(observer);
    }
    
    public static void detachObserver(ObservateurEvenements observer)
    {
    	observers.remove(observer);
    }
    */
    
    /**
     * Utilise pour retourner un message qui sera eventuellement affiche a l'utilisateur.
     * @return
     */
    public abstract String getMessage();
    public abstract String toString();
}
